#include "font.h"

FONT_INF Fonts[NUM_FONTS];
int wid, pid;
QW_FONT_METRIC metric;

void main()
{
   int sid;
   QW_EVENT_MSG evnt;
   char *menu_list;
   int num_fonts;

   if ( !(sid = GraphicsOpen(NULL)) )
   {
     printf("For use with QNX windows only.\n");
     exit(-1);
   }
   num_fonts = getfontlist();  
   make_menu_list(num_fonts, &menu_list);
   init( );

   DialogAt( 100, 100, NULL, NULL );
   Menu("fm", "Please select a font", 1, menu_list, "P");

   while (1)
   {
     GetEvent(0, &evnt, sizeof(evnt) );
     switch( Event( &evnt ) )
     {
       case QW_QUIT:
         DialogCancel( QW_ALL, "P" );
       case QW_CANCELLED:
       case QW_CLOSED:
         GraphicsClose( sid );
       case QW_TERMINATED:  
         exit(-1);
         break;
       case QW_DIALOG:
         demo_font( &evnt );
         break;
       case QW_CLICK:
         if ( !strcmp( evnt.hdr.key, "savep" ) )
           save_picture();
         break;
     }  
   }      
}

void make_menu_list( int num_fonts, char **menu_list )
{
  char *p, *name, *style;
  int i;

  *menu_list = malloc( 33*num_fonts + 10 );
  p = *menu_list;
  for( i=0; i < num_fonts; i++ )
  {
    if (!strcmp(Fonts[i].name, TIMES_FN) )
      name = TIMES;
    else if (!strcmp(Fonts[i].name, COUR_FN) )
      name = COUR;
    else if (!strcmp(Fonts[i].name, CHAR_FN) )
      name = CHAR;
    else if (!strcmp(Fonts[i].name, HELV_FN) )
      name = HELV;
    else if (!strcmp(Fonts[i].name, NCEN_FN) )
      name = NCEN;
    else
      name = Fonts[i].name; 
    if (!strcmp(Fonts[i].style, BOLD_FN) )
      style = BOLD;
    else if (!strcmp(Fonts[i].style, NORM_FN) )
      style = NORM;
    else if (!strcmp(Fonts[i].style, B_I_FN) )
      style = B_I;
    else if (!strcmp(Fonts[i].style, ITAL_FN) )
      style = ITAL;
    else
      style = Fonts[i].style;

    sprintf(p, "%-11s  %-11s  %2d|%3d;", name, style, Fonts[i].size, i );
    p += 33;
  }
  p[-1] = '\0'; /* remove final ; from string */
}

void demo_font( QW_EVENT_MSG *evnt )
{
  int i;
  int num_fonts;
  
  i = atoi( evnt->hdr.key );
  
  printf("name: %s, style: %s, size: %d\n", 
         Fonts[i].name, Fonts[i].style, Fonts[i].size * QW_V_TPP );
  if ( !Fonts[i].loaded ) {
    int id;
    id = ScreenFont( Fonts[i].name, Fonts[i].style, 0, Fonts[i].size * QW_V_TPP, "L" );
    Fonts[i].loaded = 1;
    ScreenFontList( &num_fonts, NULL );
    printf("Screen has: %d fonts loaded.\n", num_fonts);
    ScreenFontInfo( id, NULL, NULL, NULL, NULL, NULL, &metric );
    printf("Font metrics are: min: %d, max: %d; n_chars: %d\n",
           metric.min, metric.max, metric.n_chars );
  }
  if (!strcmp(Fonts[i].style, NORM_FN) )
    SetFont( "PTb", Fonts[i].name, NULL, 0, Fonts[i].size * QW_V_TPP );
  else
    SetFont( "PTb", Fonts[i].name, Fonts[i].style, 0, Fonts[i].size * QW_V_TPP );
    
  WindowHold(); 
  Erase( QW_ALL );
  DrawAt( 150, 500 );
  DrawButton( "What font is this?", NULL, "S", "but" );
  DrawAt( 400+3*Fonts[i].size*QW_V_TPP/2, 100 );
  DrawText( "This is a DrawText call.", 0, 0, 0, NULL, "text1" );
  DrawAt( 500+3*Fonts[i].size*QW_V_TPP, 100 );
  DrawText( "This is an editable DrawText call.", 0, 0, 0, "ES", "text2" );
  DrawAt( 600+9*Fonts[i].size*QW_V_TPP/2, 100 );
  DrawPara( "This is a longer text string, being used in a DrawPara "
            "call.  It should be long enough to go at least two or "
            "three lines in most fonts.  Though in smaller fonts it "
            "might all fit on one line.",
            2000, 4000, NULL, "para" );
  Draw();
  WindowContinue();
}

void save_picture()
{
	char path[255], *fl, *pt; 
	getcwd( path, 255 );
	fl = FileMenu( NULL, "Put picture file where?", NULL, path, "*.pict", "bntuo",
	               &pt, NULL );
	if (fl)
	{
	  strcpy(path, pt);
	  strcat(path, "/" );
	  strcat(path, fl );
	  PictureSave( path );
	}
	else 
	  printf("fmenu returned null\n");
}
void init()
{
  pid = Picture( "Font test pict", NULL );
  WindowAt( 100, 3000, NULL, NULL );
  wid = WindowOpen("Font test window" , 4000, 5000, "T+1;j(t)", NULL, "Font test", pid );
  WindowBarCurrent( 'T', NULL );
  DrawAt( 280, 280);
  DrawButton( "Save Picture", NULL, NULL, "savep" );
  Draw();
  PictureCurrent( pid );
}
